﻿Public Class SimpleRTB
    Inherits System.Windows.Forms.RichTextBox

    ' ===============================================================================================
    '  ENABLE DISABLE PAINT and DISABLE ZOOM with CTRL WHEEL
    ' ===============================================================================================
    Friend PaintEventEnabled As Boolean = True

    Private Const MK_CONTROL As Int32 = &H8
    Private Const WM_MOUSEWHEEL As Int32 = &H20A

    <DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        Const WM_PAINT As Int32 = &HF
        If m.Msg = WM_PAINT AndAlso Not PaintEventEnabled Then
            m.Result = IntPtr.Zero
        ElseIf m.Msg = WM_MOUSEWHEEL Then
            If (m.WParam.ToInt32 And MK_CONTROL) = MK_CONTROL Then
                m.WParam = IntPtr.Zero
                m.Result = IntPtr.Zero
            Else
                MyBase.WndProc(m)
            End If
        Else
            MyBase.WndProc(m)
        End If
    End Sub

    Private Sub Me_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        ' -------------------------------------------------- suppress RTB sounds
        RichTextBox_SuppressSounds(sender, e)
    End Sub


    'Private Sub PrintTextBox_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles PrintTextBox.KeyDown
    '    ' TODO COPY FROM TEXT BOX

    '    ' ------------------------------------------------------------- CUT / COPY / PASTE / UNDO / REDO
    '    'If My.Computer.Keyboard.CtrlKeyDown Then
    '    '    e.SuppressKeyPress = True
    '    '    e.Handled = True
    '    '    Select Case e.KeyCode
    '    '        'Case Keys.F : Editor_Find()
    '    '        'Case Keys.R : Editor_FindReplace()
    '    '        Case Keys.X : RTB.ExecCut()
    '    '        Case Keys.C : RTB.ExecCopy()
    '    '        Case Keys.V : RTB.ExecPaste()
    '    '        Case Keys.Z : RTB.ExecUndo()
    '    '        Case Keys.Y : RTB.ExecRedo()
    '    '        Case Keys.Space : RTB.CompleteKeyword()
    '    '        Case Else
    '    '            e.Handled = False
    '    '            e.SuppressKeyPress = False
    '    '    End Select
    '    'End If

    '    'Dim data As IDataObject
    '    'data = New DataObject(DataFormats.Text, PrintTextBox.SelectedText.Replace(vbLf, vbCrLf))
    '    'Clipboard.SetDataObject(data, True)
    'End Sub

    'Protected Overrides Function IsInputKey(ByVal keyData As Keys) As Boolean
    '    Select Case (keyData)
    '        Case Keys.Right, Keys.Left, Keys.Up, Keys.Down
    '            Return True
    '        Case Keys.Shift Or Keys.Right, Keys.Shift Or Keys.Left, Keys.Shift Or Keys.Up, Keys.Shift Or Keys.Down
    '            Return True
    '    End Select
    '    Return MyBase.IsInputKey(keyData)
    'End Function

    'Protected Overrides Sub OnKeyDown(ByVal e As KeyEventArgs)
    '    MyBase.OnKeyDown(e)
    '    Select Case (e.KeyCode)
    '        Case Keys.Left, Keys.Right, Keys.Up, Keys.Down
    '            If e.Shift Then

    '            Else

    '            End If
    '    End Select
    'End Sub

End Class
